#if !defined(__KSSTRING_H)
#define __KSSTRING_H

#include "Delay.h"

//Karplus Strong string model class

//Note: this class has no error checking (for delay lengths and such).

#define SAMPLE double

class KSString
{
public:
	
	//Constructor
	KSString(double lowestFreqIn, double frequencyIn, double fs, double feedbackGainIn);
	
	//Destructor
	~KSString();
	
	//Utility fns
	double getFrequency() { return frequency; };
	double getFeedbackGain() { return feedbackGain; };
	void setFrequency(double frequencyIn);
	void setFeedbackGain(double feedbackGainIn) { feedbackGain = feedbackGainIn; };
	SAMPLE getLastOut() { return delayLine->getLastOut(); };
	void clear();

	//Fills the delay line with white noise
	void pluck(int velocity);	
	
	//Gets the next output sample and increments time one sample
	SAMPLE tick();
	
private:
	
	Delay* delayLine;
	double fs;
	double frequency;
	double feedbackGain;
	
};

#endif
